#!/usr/bin/perl
# fwd2mh.pl - A simple program to convert a forwarded email to the
# original email.
# Copyright 2006 Timothy Pollard
#
#All rights reserved.
#
#Redistribution and use in source and binary forms, with or without modification,
#are permitted provided that the following conditions are met:
#
#* Redistributions of source code must retain the above copyright notice, this 
#list of conditions and the following disclaimer.
#
#* Redistributions in binary form must reproduce the above copyright notice, this
#list of conditions and the following disclaimer in the documentation and/or 
#other materials provided with the distribution.
#
#THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
#ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
#WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
#DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE 
#FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
#DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
#SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
#CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
#OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
#OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# Open the file for read.
open (INFILE, "<", $ARGV [0]) or die ("Unable to open the file");

# Read the file into a string. (Handles up to 100MB files)
read (INFILE, $file, 100000000);

# Close the file.
close (INFILE);

# Generate the new string.
$file = generate_new_string ($file);

# Open the file for write.
open (OUTFILE, ">", $ARGV [0]) or die ("Unable to open the file");

# Write the string to the file.
print OUTFILE $file;

# Close the file.
close (OUTFILE);

# Find the index of the string passed as an argument
sub find_index
{
    $index = $_ [1];
    while ($index <= @file_array.length() / 100)
    {
        if ($file_array [$index] =~ $_ [0])
        {   
            return $index;
        }
        $index++;
    }
    return -1;
}

# Generates the new string
sub generate_new_string
{
    # Split on newlines.
    @file_array = split ("\n", $_ [0]);

    # Find the index of "X-HM-IDENT: attach".
    $index = find_index ("X-HM-IDENT: attach");

    # Join everything between the found index and the last two lines back together.
    $file = $file_array [$index + 1];
    for ($i = $index + 2; $i < @file_array - 2; $i++)
    {
        $file = $file . $file_array [$i] . "\n";
    }

    return $file;
}

